﻿#include <iostream>
#include <unordered_map>
using namespace std;

class Romans {
private:
  int _number;

public:
  //Define the getter
  int getNumber() {
    return this->_number;
  }

  //Define the setter
  void setNumber(int value) {
    if (value >= 1 && value <= 5) {
      this->_number = value;
    }
    else {
      throw "Number not recognized";
    }
  }

  //Define the getter
  string getRoman() {
    unordered_map<int, string> number2roman = {
      { 1, "I" }, { 2, "II" }, { 3, "III" }, { 4, "IV"}, { 5, "V"}
    };
    return number2roman[this->_number];
  }

  //Define the setter
  void setRoman(string value) {
    unordered_map<string, int> roman2number = {
      { "I", 1 }, { "II", 2 }, { "III", 3 }, { "IV", 4}, { "V", 5}
    };

    if (roman2number.count(value) > 0) {
      this->_number = roman2number[value];
    }
    else {
      throw "Roman numeral not recognized";
    }
  }
};

int main() {
  Romans x;

  x.setNumber(3);
  cout << x.getNumber() << endl;  //It displays: 3
  cout << x.getRoman() << endl;   //It displays: III

  x.setRoman("V");
  cout << x.getNumber() << endl;  //It displays: 5
  cout << x.getRoman() << endl;   //It displays: V
  return 0;
}
