﻿#include <iostream>
using namespace std;

class SchoolMember {
private:
  string _name;
  int _age;

public:
  //Define the constructor
  SchoolMember(string name, int age) {
    this->setName(name);
    this->setAge(age);
    cout << "A school member was initialized" << endl;
  }

  //Define the getter
  string getName() {
    return this->_name;
  }

  //Define the setter
  void setName(string value) {
    if (value != "")
      this->_name = value;
    else
      throw "Name cannot be empty";
  }

  //Define the getter
  int getAge() {
    return this->_age;
  }

  //Define the setter
  void setAge(int value) {
    if (value > 0)
      this->_age = value;
    else
      throw "Age cannot be negative or zero";
  }
};

class Teacher : public SchoolMember {
private:
  double _salary;  //This is an additional field for class Teacher

public:
  //Define the constructor
  Teacher(string name, int age, double salary) : SchoolMember(name, age) {
    this->setSalary(salary);
    cout << "A teacher was initialized" << endl;
  }

  //Define the getter
  double getSalary() {
    return this->_salary;
  }

  //Define the setter
  void setSalary(double value) {
    if (value >= 0)
      this->_salary = value;
    else
      throw "Salary cannot be negative";
  }
};

class Student : public SchoolMember {
private:
  int _final_grade;  //This is an additional field for class Student

public:
  //Define the constructor
  Student(string name, int age, int final_grade) : SchoolMember(name, age) {
    this->setGrade(final_grade);
    cout << "A student was initialized" << endl;
  }

  //Define the getter
  int getGrade() {
    return this->_final_grade;
  }

  //Define the setter
  void setGrade(int value) {
    if (value >= 0 && value <= 100)
      this->_final_grade = value;
    else
      throw "Grade must be between 0 and 100";
  }
};

int main() {
  Teacher teacher1("Mr. John Scott", 43, 35000);
  Teacher teacher2("Mrs. Ann Carter", 5, 32000);

  Student student1("Mark Nelson", 14, 95);
  Student student2("Mary Morgan", 13, 93);

  cout << teacher1.getName() << endl;
  cout << teacher1.getAge() << endl;
  cout << teacher1.getSalary() << endl;

  cout << student2.getName() << endl;
  cout << student2.getAge() << endl;
  cout << student2.getGrade() << endl;
  return 0;
}
